(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'terminal-in-react', 'core-decorators'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('terminal-in-react'), require('core-decorators'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.React, global.terminalInReact, global.coreDecorators);
    global.index = mod.exports;
  }
})(this, function (exports, _react, _terminalInReact, _coreDecorators) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;

  var _react2 = _interopRequireDefault(_react);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var _class, _class2, _temp;

  var VI = (0, _coreDecorators.autobind)(_class = (_temp = _class2 = function (_PluginBase) {
    _inherits(VI, _PluginBase);

    function VI(api) {
      var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { filesystem: 'Pass `filesystem` into config' };

      _classCallCheck(this, VI);

      var _this = _possibleConstructorReturn(this, (VI.__proto__ || Object.getPrototypeOf(VI)).call(this, api, config));

      _this.commands = {
        vi: _this.viCommand()
      };
      _this.descriptions = {
        vi: 'Open a file to be edited'
      };
      return _this;
    }

    _createClass(VI, [{
      key: 'handleWrapperRef',
      value: function handleWrapperRef(wrapper) {
        if (wrapper !== null) {
          this.api.setScrollPosition(0);
          this.api.setCanScroll(false);
        }
      }
    }, {
      key: 'runVi',
      value: function runVi(contents, save) {
        var _this2 = this;

        var handleChange = function handleChange(e) {
          // console.warn(e.target);
        };
        var handleKeyPressOuter = function handleKeyPressOuter(e) {
          e.preventDefault();
          e.stopPropagation();
          if (e.key === 'Escape') {
            var str = _this2.viEditor.innerHTML;
            str = str.replace(/<(\/)?br>/gi, '\n');
            str = str.replace(/<p[^<]*>/gi, '\n');
            str = str.replace(/<div[^<]*>/gi, '\n');
            str = str.replace(/<(?:.|\s)*?>/g, '');
            save(str);
          }
        };
        this.api.printLine(_react2.default.createElement(
          'div',
          {
            style: {
              position: 'absolute',
              top: 0,
              left: 0,
              right: 0,
              bottom: 0,
              backgroundColor: 'black',
              color: 'inherit',
              padding: 10,
              fontSize: 12
            },
            ref: this.handleWrapperRef,
            tabIndex: '0',
            onKeyUp: handleKeyPressOuter
          },
          _react2.default.createElement('code', {
            style: {
              width: '100%',
              height: '100%',
              outline: 'none',
              display: 'block'
            },
            contentEditable: true,
            ref: function ref(e) {
              if (e !== null) {
                e.focus();
              }
              _this2.viEditor = e;
            },
            onInput: handleChange,
            onBlur: handleChange,
            dangerouslySetInnerHTML: { __html: contents }
          })
        ));
      }
    }, {
      key: 'viCommand',
      value: function viCommand() {
        var _this3 = this;

        return {
          method: function method(args) {
            var parsePath = _this3.api.getPluginMethod(_this3.config.filesystem, 'parsePath');
            var readFile = _this3.api.getPluginMethod(_this3.config.filesystem, 'readFile');
            var writeFile = _this3.api.getPluginMethod(_this3.config.filesystem, 'writeFile');
            var createFile = _this3.api.getPluginMethod(_this3.config.filesystem, 'createFile');
            if (args._.length > 0) {
              var path = parsePath(args._[0]);
              var file = readFile(path);
              if (file !== null && typeof file === 'string') {
                _this3.runVi(file, function (newContents) {
                  writeFile(path, newContents);
                  _this3.api.removeLine();
                });
              } else if (file === null) {
                _this3.api.removeLine();
                _this3.runVi('', function (newContents) {
                  createFile(path);
                  writeFile(path, newContents);
                  _this3.api.removeLine();
                  _this3.api.setCanScroll(true);
                  _this3.api.focusInput();
                });
              }
            }
          }
        };
      }
    }]);

    return VI;
  }(_terminalInReact.PluginBase), _class2.displayName = 'VI', _class2.version = '1.0.1', _temp)) || _class;

  exports.default = VI;
});